﻿<%@ WebHandler Language="C#" Class="GetFileList" %>

using System;
using System.IO;
using System.Web;

public class GetFileList : IHttpHandler
{
	//This is a base server folder for subfolders, between which the user can choose
	private const string strBasePath = "~/BasicDemo/Files";

	public void ProcessRequest(HttpContext context)
	{
		context.Response.ContentType = "text/plain";
		context.Response.CacheControl = "no-cache";
		
		string strFolderPath = "Folder1";
		string strRequest = context.Request.QueryString["id"];
		//Change the subfolder, if needed
		switch (strRequest)
		{
			case "1":
				strFolderPath = "Folder1";
				break;
			case "2":
				strFolderPath = "Folder2";
				break;
			case "3":
				strFolderPath = "Folder3";
				break;
		}

		//Check if the selected subfolder exists
		string virtualFolderPath = strBasePath + "/" + strFolderPath;
		string absFolderPath = context.Server.MapPath(virtualFolderPath);
		if (Directory.Exists(absFolderPath))
		{
			DirectoryInfo objDir = new DirectoryInfo(absFolderPath);
			//Iterate through all files in the subfolder and build a file list
			foreach (FileInfo objFile in objDir.GetFiles())
			{
				//Add the MIME type, the size, and the name for saving
				context.Response.Write("*/* | " + objFile.Length + " | " + objFile.Name + " | ");
				
				//Add the URL to the file and the CRLF combination
				string fileUrl = VirtualPathUtility.ToAbsolute(virtualFolderPath + "/" + objFile.Name);
				context.Response.Write(Uri.EscapeUriString(fileUrl) + "\r\n");
			}
		}
	}

	public bool IsReusable
	{
		get
		{
			return false;
		}
	}

}